//stafflnd.java
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.dll.*;

/**
 * @author: Application Wizard
 * @version: 1.0
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'stafflnd' is
 * created in the main() method.
 */ 

class stafflnd extends Form
{

   public stafflnd()
   {
      super();

      //Required for Visual J++ Form Designer support
      initForm();		

   }


   /**
    * stafflnd overrides dispose so it can clean up the
    * component list.
    */
   public void dispose()
   {
      super.dispose();
      components.dispose();
   }

   // Global Variables
   //private static int nErrorCode[] = new int[1];

   private void Solve_click(Object source, Event e)
   {
      // Get staffing needs from dialog box
      double dNeeds[] = new double[7];
      dNeeds[0] = new Double(needsMon.getText()).doubleValue();
      dNeeds[1] = new Double(needsTue.getText()).doubleValue();
      dNeeds[2] = new Double(needsWed.getText()).doubleValue();
      dNeeds[3] = new Double(needsThu.getText()).doubleValue();
      dNeeds[4] = new Double(needsFri.getText()).doubleValue();
      dNeeds[5] = new Double(needsSat.getText()).doubleValue();
      dNeeds[6] = new Double(needsSun.getText()).doubleValue();

      // create the LINGO environment object
      int pLINGO;
      pLINGO = Lingo.LScreateEnvLng( );
		
      if ( pLINGO == 0)
      {
         MessageBox.show("Unable to solve!");
         
      } else ErrorExit: {
		
         // open LINGO's log file
         int nError = Lingo.LSopenLogFileLng( pLINGO, "staffjva.log");
         if ( nError > 0) break ErrorExit;
         

         // Pass memory transfer pointers to LINGO
         // @POINTER(1)
         int nPointersNow[] = new int[1];
         nError = Lingo.LSsetPointerLng( pLINGO, dNeeds, nPointersNow); 
         if ( nError > 0) break ErrorExit;

         // @POINTER(2)
         double dStart[] = new double[7];
         nError = Lingo.LSsetPointerLng( pLINGO, dStart, nPointersNow);
         if ( nError > 0) break ErrorExit;

         // @POINTER(3)
         double dOnDuty[] = new double[7];
         nError = Lingo.LSsetPointerLng( pLINGO, dOnDuty, nPointersNow);
         if ( nError > 0) break ErrorExit;

         // @POINTER(4)
         double dTotal[] = new double[7];
         nError = Lingo.LSsetPointerLng( pLINGO, dTotal, nPointersNow);
         if ( nError > 0) break ErrorExit;

         // @POINTER(5)
         double dStatus[] = new double[1];
         nError = Lingo.LSsetPointerLng( pLINGO, dStatus, nPointersNow);
         if ( nError > 0) break ErrorExit;
         
         // Build LINGO's command script
         String cScript = "TAKE \\LINGO8\\SAMPLES\\STAFFPTR.LNG \n GO \n QUIT \n";
       
         nError = Lingo.LSexecuteScriptLng( pLINGO, cScript);
         
         if( nError > 0 || dStatus[0] > 0)
         {
            MessageBox.show("Unable to solve!");
            break ErrorExit;
         } else {
            // Display solution in dialog box
            startMon.setText(new Integer((int)dStart[0]).toString());
            startTue.setText(new Integer((int)dStart[1]).toString());
            startWed.setText(new Integer((int)dStart[2]).toString());
            startThu.setText(new Integer((int)dStart[3]).toString());
            startFri.setText(new Integer((int)dStart[4]).toString());
            startSat.setText(new Integer((int)dStart[5]).toString());
            startSun.setText(new Integer((int)dStart[6]).toString());
            onMon.setText(new Integer((int)(dOnDuty[0])).toString());
            onTue.setText(new Integer((int)(dOnDuty[1])).toString());
            onWed.setText(new Integer((int)(dOnDuty[2])).toString());
            onThu.setText(new Integer((int)(dOnDuty[3])).toString());
            onFri.setText(new Integer((int)(dOnDuty[4])).toString());
            onSat.setText(new Integer((int)(dOnDuty[5])).toString());
            onSun.setText(new Integer((int)(dOnDuty[6])).toString());
            total.setText(new Integer((int)(dTotal[0])).toString());
         }
      }
      
      // Release the Lingo environment object
         Lingo.LSdeleteEnvLng( pLINGO);
	}

   private void Exit_click(Object source, Event e)
   {
      Application.exit();
   }

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */

	Container components = new Container();
	GroupBox groupBox2 = new GroupBox();
	GroupBox groupBox1 = new GroupBox();
	Button Solve = new Button();
	Button Exit = new Button();
	Label lDay = new Label();
	Label lNeeds = new Label();
	Label lStart = new Label();
	Label lDuty = new Label();
	Label lMon = new Label();
	Label lTue = new Label();
	Label lWed = new Label();
	Label lThu = new Label();
	Label lFri = new Label();
	Label lSat = new Label();
	Label lSun = new Label();
	Edit needsMon = new Edit();
	Edit needsWed = new Edit();
	Edit needsTue = new Edit();
	Edit needsThu = new Edit();
	Edit needsFri = new Edit();
	Edit needsSat = new Edit();
	Edit needsSun = new Edit();
	Edit startSun = new Edit();
	Edit startSat = new Edit();
	Edit startFri = new Edit();
	Edit startThu = new Edit();
	Edit startWed = new Edit();
	Edit startTue = new Edit();
	Edit startMon = new Edit();
	Edit onMon = new Edit();
	Edit onTue = new Edit();
	Edit onWed = new Edit();
	Edit onThu = new Edit();
	Edit onFri = new Edit();
	Edit onSat = new Edit();
	Edit onSun = new Edit();
	Edit total = new Edit();
	Label lTotal = new Label();

	private void initForm()
	{
		this.setAnchor(ControlAnchor.ALL);
		this.setLocation(new Point(298, 88));
		this.setText("Staff Scheduling Example Using the LINDO API");
		this.setAutoScaleBaseSize(new Point(5, 13));
		this.setBorderStyle(FormBorderStyle.FIXED_SINGLE);
		this.setClientSize(new Point(403, 270));

		groupBox2.setLocation(new Point(24, 32));
		groupBox2.setSize(new Point(256, 184));
		groupBox2.setTabIndex(2);
		groupBox2.setTabStop(false);
		groupBox2.setText("");

		groupBox1.setLocation(new Point(8, 8));
		groupBox1.setSize(new Point(384, 248));
		groupBox1.setTabIndex(0);
		groupBox1.setTabStop(false);
		groupBox1.setText("");

		Solve.setLocation(new Point(296, 16));
		Solve.setSize(new Point(75, 23));
		Solve.setTabIndex(1);
		Solve.setText("Solve");
		Solve.addOnClick(new EventHandler(this.Solve_click));

		Exit.setLocation(new Point(296, 40));
		Exit.setSize(new Point(75, 23));
		Exit.setTabIndex(3);
		Exit.setText("Exit");
		Exit.addOnClick(new EventHandler(this.Exit_click));

		lDay.setLocation(new Point(40, 16));
		lDay.setSize(new Point(40, 16));
		lDay.setTabIndex(15);
		lDay.setTabStop(false);
		lDay.setText("Day");

		lNeeds.setLocation(new Point(88, 16));
		lNeeds.setSize(new Point(40, 16));
		lNeeds.setTabIndex(14);
		lNeeds.setTabStop(false);
		lNeeds.setText("Needs");

		lStart.setLocation(new Point(160, 16));
		lStart.setSize(new Point(40, 16));
		lStart.setTabIndex(13);
		lStart.setTabStop(false);
		lStart.setText("Start");

		lDuty.setLocation(new Point(216, 16));
		lDuty.setSize(new Point(40, 16));
		lDuty.setTabIndex(12);
		lDuty.setTabStop(false);
		lDuty.setText("On Duty");

		lMon.setLocation(new Point(41, 48));
		lMon.setSize(new Point(40, 16));
		lMon.setTabIndex(11);
		lMon.setTabStop(false);
		lMon.setText("Mon");

		lTue.setLocation(new Point(40, 72));
		lTue.setSize(new Point(40, 16));
		lTue.setTabIndex(9);
		lTue.setTabStop(false);
		lTue.setText("Tue");

		lWed.setLocation(new Point(40, 96));
		lWed.setSize(new Point(40, 16));
		lWed.setTabIndex(10);
		lWed.setTabStop(false);
		lWed.setText("Wed");

		lThu.setLocation(new Point(40, 120));
		lThu.setSize(new Point(40, 16));
		lThu.setTabIndex(7);
		lThu.setTabStop(false);
		lThu.setText("Thu");

		lFri.setLocation(new Point(40, 144));
		lFri.setSize(new Point(40, 16));
		lFri.setTabIndex(8);
		lFri.setTabStop(false);
		lFri.setText("Fri");

		lSat.setLocation(new Point(40, 168));
		lSat.setSize(new Point(40, 16));
		lSat.setTabIndex(4);
		lSat.setTabStop(false);
		lSat.setText("Sat");

		lSun.setLocation(new Point(40, 192));
		lSun.setSize(new Point(40, 16));
		lSun.setTabIndex(6);
		lSun.setTabStop(false);
		lSun.setText("Sun");

		needsMon.setLocation(new Point(56, 16));
		needsMon.setSize(new Point(48, 20));
		needsMon.setTabIndex(20);
		needsMon.setText("0");
		needsMon.setAcceptsReturn(false);
		needsMon.setMaxLength(4);

		needsWed.setLocation(new Point(56, 64));
		needsWed.setSize(new Point(48, 20));
		needsWed.setTabIndex(18);
		needsWed.setText("0");
		needsWed.setMaxLength(4);

		needsTue.setLocation(new Point(56, 40));
		needsTue.setSize(new Point(48, 20));
		needsTue.setTabIndex(19);
		needsTue.setText("0");
		needsTue.setMaxLength(4);

		needsThu.setLocation(new Point(56, 88));
		needsThu.setSize(new Point(48, 20));
		needsThu.setTabIndex(17);
		needsThu.setText("0");
		needsThu.setMaxLength(4);

		needsFri.setLocation(new Point(56, 112));
		needsFri.setSize(new Point(48, 20));
		needsFri.setTabIndex(16);
		needsFri.setText("0");
		needsFri.setMaxLength(4);

		needsSat.setLocation(new Point(56, 135));
		needsSat.setSize(new Point(48, 20));
		needsSat.setTabIndex(15);
		needsSat.setText("0");
		needsSat.setMaxLength(4);

		needsSun.setLocation(new Point(56, 159));
		needsSun.setSize(new Point(48, 20));
		needsSun.setTabIndex(14);
		needsSun.setText("0");
		needsSun.setMaxLength(4);

		startSun.setBackColor(Color.INACTIVEBORDER);
		startSun.setLocation(new Point(128, 160));
		startSun.setSize(new Point(48, 20));
		startSun.setTabIndex(7);
		startSun.setText("");
		startSun.setReadOnly(true);

		startSat.setBackColor(Color.INACTIVEBORDER);
		startSat.setLocation(new Point(128, 136));
		startSat.setSize(new Point(48, 20));
		startSat.setTabIndex(8);
		startSat.setText("");
		startSat.setReadOnly(true);

		startFri.setBackColor(Color.INACTIVEBORDER);
		startFri.setLocation(new Point(128, 112));
		startFri.setSize(new Point(48, 20));
		startFri.setTabIndex(9);
		startFri.setText("");
		startFri.setReadOnly(true);

		startThu.setBackColor(Color.INACTIVEBORDER);
		startThu.setLocation(new Point(128, 88));
		startThu.setSize(new Point(48, 20));
		startThu.setTabIndex(10);
		startThu.setText("");
		startThu.setReadOnly(true);

		startWed.setBackColor(Color.INACTIVEBORDER);
		startWed.setLocation(new Point(128, 64));
		startWed.setSize(new Point(48, 20));
		startWed.setTabIndex(11);
		startWed.setText("");
		startWed.setReadOnly(true);

		startTue.setBackColor(Color.INACTIVEBORDER);
		startTue.setLocation(new Point(128, 40));
		startTue.setSize(new Point(48, 20));
		startTue.setTabIndex(12);
		startTue.setText("");
		startTue.setReadOnly(true);

		startMon.setBackColor(Color.INACTIVEBORDER);
		startMon.setLocation(new Point(128, 16));
		startMon.setSize(new Point(48, 20));
		startMon.setTabIndex(13);
		startMon.setText("");
		startMon.setReadOnly(true);

		onMon.setBackColor(Color.INACTIVEBORDER);
		onMon.setLocation(new Point(192, 16));
		onMon.setSize(new Point(48, 20));
		onMon.setTabIndex(6);
		onMon.setText("");
		onMon.setReadOnly(true);

		onTue.setBackColor(Color.INACTIVEBORDER);
		onTue.setLocation(new Point(192, 40));
		onTue.setSize(new Point(48, 20));
		onTue.setTabIndex(5);
		onTue.setText("");
		onTue.setReadOnly(true);

		onWed.setBackColor(Color.INACTIVEBORDER);
		onWed.setLocation(new Point(192, 64));
		onWed.setSize(new Point(48, 20));
		onWed.setTabIndex(4);
		onWed.setText("");
		onWed.setReadOnly(true);

		onThu.setBackColor(Color.INACTIVEBORDER);
		onThu.setLocation(new Point(192, 88));
		onThu.setSize(new Point(48, 20));
		onThu.setTabIndex(3);
		onThu.setText("");
		onThu.setReadOnly(true);

		onFri.setBackColor(Color.INACTIVEBORDER);
		onFri.setLocation(new Point(192, 112));
		onFri.setSize(new Point(48, 20));
		onFri.setTabIndex(2);
		onFri.setText("");
		onFri.setReadOnly(true);

		onSat.setBackColor(Color.INACTIVEBORDER);
		onSat.setLocation(new Point(192, 136));
		onSat.setSize(new Point(48, 20));
		onSat.setTabIndex(1);
		onSat.setText("");
		onSat.setReadOnly(true);

		onSun.setBackColor(Color.INACTIVEBORDER);
		onSun.setLocation(new Point(192, 160));
		onSun.setSize(new Point(48, 20));
		onSun.setTabIndex(0);
		onSun.setText("");
		onSun.setReadOnly(true);

		total.setBackColor(Color.INACTIVEBORDER);
		total.setLocation(new Point(128, 224));
		total.setSize(new Point(72, 20));
		total.setTabIndex(0);
		total.setText("");
		total.setReadOnly(true);

		lTotal.setLocation(new Point(96, 224));
		lTotal.setSize(new Point(32, 16));
		lTotal.setTabIndex(5);
		lTotal.setTabStop(false);
		lTotal.setText("Total:");

		this.setNewControls(new Control[] {
							groupBox1});
		groupBox2.setNewControls(new Control[] {
								 onMon, 
								 onTue, 
								 onWed, 
								 onThu, 
								 onFri, 
								 onSat, 
								 onSun, 
								 startMon, 
								 startTue, 
								 startWed, 
								 startThu, 
								 startFri, 
								 startSat, 
								 startSun, 
								 needsSun, 
								 needsSat, 
								 needsFri, 
								 needsThu, 
								 needsWed, 
								 needsTue, 
								 needsMon});
		groupBox1.setNewControls(new Control[] {
								 lTotal, 
								 total, 
								 lSun, 
								 lSat, 
								 lFri, 
								 lThu, 
								 lWed, 
								 lTue, 
								 lMon, 
								 lDuty, 
								 lStart, 
								 lNeeds, 
								 lDay, 
								 Exit, 
								 Solve, 
								 groupBox2});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new stafflnd());
	}
}
