import com.ms.dll.*;

class MyCallback extends Callback
{
	public static int nIterations[] = new int[1];
	public static double dBound[] = new double[1];
	public static double dBestIP[] = new double[1];
	public static double dBestIPShown;
	
	/* A callback function that will be called by the LINDO solver */
	public int callback( int pLINGO, int nReserved, int nMyData)
	{
		// Callback function called by LINGO every iteration
		//
		// return value: >= 0 if solver is to continue, else < 0 to interrupt

   	// Get current best IP
      int nError =
       Lingo.LSgetCallbackInfoLng( pLINGO, 
        Lingo.LS_DINFO_MIP_BEST_OBJECTIVE_LNG, dBestIP);

      // Is current better than last shown
		if ( nError == 0 && dBestIP[0] < dBestIPShown)
		{
         // Store current IP value
         dBestIPShown = dBestIP[0];
			
         // Get iteration count from LINGO
         Lingo.LSgetCallbackInfoLng( pLINGO, Lingo.LS_IINFO_ITERATIONS_LNG, nIterations);

         // Get bound on solution
         Lingo.LSgetCallbackInfoLng( pLINGO, Lingo.LS_DINFO_MIP_BOUND_LNG, dBound);

         // Create a dialog to show the current solution value
         int nResult = new NewIPSol().showDialog();
         if ( nResult == 2)
         {
            return( 0);
         } else {
            return( -1);
         }
		}
		return( 0);
	}
}