import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.lang.Delegate;

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'NewIPSol'
 * created in the main() method.
 */
class NewIPSol extends Form
{
	public NewIPSol()
	{
		super();

		// Required for Visual J++ Form Designer support
		initForm();

		Iteration.setText(Integer.toString(MyCallback.nIterations[0]));
		Objective.setText(Double.toString(MyCallback.dBestIPShown));
		Bound.setText(Double.toString(MyCallback.dBound[0]));
		
		Interrupt.setDialogResult(-1);
		OK.setDialogResult(0);
		
		// TODO: Add any constructor code after initForm call
	}

	/**
	 * NewIPSol overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}


	private void OK_click(Object source, Event e)
	{
		this.dispose();
	}

	private void Interrupt_click(Object source, Event e)
	{
		this.dispose();
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Button Interrupt = new Button();
	Button OK = new Button();
	Label lIteration = new Label();
	Label lObjective = new Label();
	Label lBound = new Label();
	Edit Iteration = new Edit();
	Edit Objective = new Edit();
	Edit Bound = new Edit();

	private void initForm()
	{
		this.setText("New Integer Solution:");
		this.setAutoScaleBaseSize(new Point(5, 13));
		this.setBorderStyle(FormBorderStyle.FIXED_SINGLE);
		this.setClientSize(new Point(240, 143));

		Interrupt.setLocation(new Point(32, 104));
		Interrupt.setSize(new Point(75, 23));
		Interrupt.setTabIndex(1);
		Interrupt.setText("Interrupt");
		Interrupt.addOnClick(new EventHandler(this.Interrupt_click));

		OK.setLocation(new Point(136, 104));
		OK.setSize(new Point(75, 23));
		OK.setTabIndex(0);
		OK.setText("OK");
		OK.addOnClick(new EventHandler(this.OK_click));

		lIteration.setLocation(new Point(48, 24));
		lIteration.setSize(new Point(48, 16));
		lIteration.setTabIndex(4);
		lIteration.setTabStop(false);
		lIteration.setText("Iteration:");

		lObjective.setLocation(new Point(48, 48));
		lObjective.setSize(new Point(48, 16));
		lObjective.setTabIndex(3);
		lObjective.setTabStop(false);
		lObjective.setText("Objective:");

		lBound.setLocation(new Point(48, 72));
		lBound.setSize(new Point(48, 16));
		lBound.setTabIndex(2);
		lBound.setTabStop(false);
		lBound.setText("Bound:");

		Iteration.setLocation(new Point(120, 24));
		Iteration.setSize(new Point(80, 20));
		Iteration.setTabIndex(7);
		Iteration.setText("");
		Iteration.setReadOnly(true);

		Objective.setLocation(new Point(120, 48));
		Objective.setSize(new Point(80, 20));
		Objective.setTabIndex(6);
		Objective.setText("");
		Objective.setReadOnly(true);

		Bound.setLocation(new Point(120, 72));
		Bound.setSize(new Point(80, 20));
		Bound.setTabIndex(5);
		Bound.setText("");
		Bound.setReadOnly(true);

		this.setNewControls(new Control[] {
							Bound, 
							Objective, 
							Iteration, 
							lBound, 
							lObjective, 
							lIteration, 
							OK, 
							Interrupt});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main()
	{
		Application.run(new NewIPSol());
	}
   public static class ClassInfo extends Form.ClassInfo
   {
      public void getEvents(IEvents events)
      {
         super.getEvents(events);
      }

      public void getProperties(IProperties props)
      {
         super.getProperties(props);
      }
   }
}
